/*
	File:			PGPUAMclientLoginDialog.h

	Description:	Handles the PGPlogin Username Dialog

	Written by:	Vinnie Moscaritolo

	Copyright:	 1998 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

	You may incorporate this sample code into your applications without
	restriction, though the sample code has been provided "AS IS" and the
	responsibility for its operation is 100% yours.  However, what you are
	not permitted to do is to redistribute the source as "DSC Sample Code"
	after having made changes. If you're going to re-distribute the source,
	we require that you make it clear in the source that the code was
	descended from Apple Sample Code, but that you've made changes.
*/

#include "TASIPPGPkey.h"
#include "TPGPUAMPrefs.h"



typedef void (*IdleConnectionProcPtr)();

typedef OSStatus (*LoginStartConnectionProcPtr) ( 	StringPtr	userName,
					 						   	StringPtr	serverName, 
					 						 	short	   *sessionRefNum,
					 						 	TPGPUAMPrefs *userPrefs,
					 							TASIPPGPkey	*serverKey,
					 				IdleConnectionProcPtr	idleProc,
					 							void 		*context);
					 							
typedef void (*CancelConnectionProcPtr)	(void  *context);


OSErr DoLoginDialog( StringPtr userName,
					 StringPtr serverName, 
					 short	   *sessionRefNum,
					 TPGPUAMPrefs*	userPrefs,
				 	 LoginStartConnectionProcPtr startProc, 
				 	 CancelConnectionProcPtr 	cancelProc,
				 	 UniversalProcPtr			eventProcUPP,
				 	 void 					 *context ) ;
