

//------------------------------------------------------------------------------------
// PGPUAM Login Command
//------------------------------------------------------------------------------------
void*  FormatLoginCmd 			(const void *outbuf, StringPtr serverVersion, StringPtr uamName, StringPtr userName, StringPtr challengeString );

typedef struct 
{
	StringPtr		userName;			// AFP User Name
	StringPtr		challengeString;	// Challenge String
}PUAM_LOGIN_CMD;

void*  FormatChallengeStr( const void   *outbuf, 
							UInt8	  	*challengeBuffer,
							UInt32	  	challengeBufferSize );

void*  ParseLoginCmd(const void *inbuf,  UInt32 *length, PUAM_LOGIN_CMD *vmsgP);


//------------------------------------------------------------------------------------
// PGPUAM Login Response
//------------------------------------------------------------------------------------
typedef struct 
{
	StringPtr	CounterChallengePString;	// Counter Challenge String
	StringPtr	FingerPrintPString;			// Fingerprint of challenged key
}PUAM_LOGIN_RESP;

 
void*  FormatLoginResp( const 	void       *outbuf, 
								StringPtr	counterChallengePString, 
 								StringPtr	fingerPrintPString );
								
void*  ParseLoginResp(const void *inbuf,  UInt32 *length, PUAM_LOGIN_RESP *vmsgP);

//------------------------------------------------------------------------------------
// PGPUAM Login Continue Command
//------------------------------------------------------------------------------------

typedef struct 
{
	StringPtr	SigPString;	// Signature reply String
 }PUAM_LOGIN_CONT_CMD;


void*  FormatLoginContinueCmd( const void   *outbuf, StringPtr	counterChallengePString );

void*  ParseLoginContinueCmd(const void *inbuf,  UInt32 *length, PUAM_LOGIN_CONT_CMD *vmsgP);
