//	TMemPGPkey.h -  In Memory PGP Key Object  
// 
// 
// Apple Macintosh Developer Technical Support
// Written by:  Vinnie Moscaritolo
//
//  Copyright (work in progress)  Apple Computer, Inc All rights reserved.
//
// You may incorporate this sample code into your applications without
// restriction, though the sample code has been provided "AS IS" and the
// responsibility for its operation is 100% yours.  However, what you are
// not permitted to do is to redistribute the source as "DSC Sample Code"
// after having made changes. If you're going to re-distribute the source,
// we require that you make it clear in the source that the code was
// descended from Apple Sample Code, but that you've made changes.
// 

#ifndef _H_TASIPPGPKEY
#define _H_TASIPPGPKEY

#include <OpenTransport.h> 

#include "TPGPkey.h"
 
// ---------------------------------------------------------------------------
//	 TASIPPGPkey - PGP Key Object 
// ---------------------------------------------------------------------------
// 
class TMemPGPkey : public  TPGPkey
{
 public: 
 
 	void* 	operator new 	(size_t size) 		{ return ::OTAllocMem (size); };
 	void 	operator delete (void* deadObject) 	{ ::OTFreeMem(deadObject); };

// 	CONSTRUCTORS AND DESTRUCTORS
			 TMemPGPkey()	:
			 			fKeySet(kInvalidPGPKeySetRef) {};

	virtual  ~TMemPGPkey();			

// MAIN INTERFACE
	virtual void Initialize(void* buf, PGPSize bufSize );	 // initialize
	
 
// ACCESSSORS
 	
 
// PRIVATE FIELDS
protected:
 	PGPKeySetRef fKeySet;

 };

#endif
