//	TPGPUAMPrefs.h - Preference Object  
// 
// Apple Macintosh Developer Technical Support
// Written by:  Vinnie Moscaritolo
//
//  Copyright (work in progress)  Apple Computer, Inc All rights reserved.
//
// You may incorporate this sample code into your applications without
// restriction, though the sample code has been provided "AS IS" and the
// responsibility for its operation is 100% yours.  However, what you are
// not permitted to do is to redistribute the source as "DSC Sample Code"
// after having made changes. If you're going to re-distribute the source,
// we require that you make it clear in the source that the code was
// descended from Apple Sample Code, but that you've made changes.
// 

#pragma once

#include <TPrefs.h>
  
// ---------------------------------------------------------------------------
//	 TPGPUAMPrefs - Preference Object  
// 
// ---------------------------------------------------------------------------
// 
class TPGPUAMPrefs  : public TPrefs
{
public:
	
  TPGPUAMPrefs() : TPrefs() , 
  					fDirty(false),
  					fDisclosureState(false),
  					fCachePassPhrase(false),
  					fAuthenticateServer(true),
  					fOption1(false),
  					fOption2(false)
  				    {};
  		
	virtual void 	Initialize();			 
	virtual void 	Finalize();		
  	

	Boolean GetDisclosureState();
	void 	SetDisclosureState(Boolean);

	Boolean GetCachePassPhrase();
	void 	SetCachePassPhrase(Boolean);
	
	SInt16 	GetCachePassPhraseTimeLimit();
	void 	SetCachePassPhraseTimeLimit(SInt16);

	Boolean GetAuthenticateServer();
	void 	SetAuthenticateServer(Boolean);

	Boolean GetOption1();
	void 	SetOption1(Boolean);

	Boolean GetOption2();
	void 	SetOption2(Boolean);
	

protected:  
	virtual OSErr 	GetPrefSpec(FSSpec *fss );
	virtual OSErr	CreatePrefFile(FSSpec *fss);		


// PRIVATE FIELDS
protected:
	Boolean fDisclosureState;
	Boolean fCachePassPhrase;
	SInt16  fCachePassPhraseTimeLimit;
 	Boolean	fAuthenticateServer;		/* require server Authentication */		 
	Boolean	fOption1;				 
	Boolean	fOption2;		 
	
	
	Boolean	fDirty;
  };

