/*
	File:		TPIFile.h

	Contains:	Interface to the TPI Module to access File Manager files.
				Technology demonstration only!

	Written by:	Quinn "The Eskimo!"

	Copyright:	 1997 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

	You may incorporate this sample code into your applications without
	restriction, though the sample code has been provided "AS IS" and the
	responsibility for its operation is 100% yours.  However, what you are
	not permitted to do is to redistribute the source as "DSC Sample Code"
	after having made changes. If you're going to re-distribute the source,
	we require that you make it clear in the source that the code was
	descended from Apple Sample Code, but that you've made changes.
*/

#include <Files.h>
#include <OpenTransport.h>

enum {
	AF_FILESPEC = 666			// FSSpec
};

struct FileSpecAddress {
	OTAddressType	fAddressType;		// Use AF_FILESPEC to denote this format.
	FSSpec			fss;
};
typedef struct FileSpecAddress FileSpecAddress, *FileSpecAddressPtr;

struct TPIFilePortInfoRecord {
	OSType 		magic1;
	OTPortRef	portRef;
	OSType 		magic2;
};
typedef struct TPIFilePortInfoRecord TPIFilePortInfoRecord, *TPIFilePortInfoRecordPtr;

enum {
	kTPIFilePerStreamDataMagic = 'ESK0',
	kTPIFilePortInfoMagic1 = 'ESK1',
	kTPIFilePortInfoMagic2 = 'ESK2'
};

#define kTPIFilePortName "TPIFile"
