/*
	File:		ProviderFactory.h

	Contains:	Interface to our provider factory library.

	Written by: Quinn "The Eskimo!"	

	Copyright:	Copyright  1997-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				7/23/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
				

*/
////////////////////////////////////////////////////////////
// Pick up general Open Transport stuff.

#include <OpenTransport.h>

////////////////////////////////////////////////////////////
// Provider factory definitions.

extern OSStatus FactoryCreateEndpoint(EndpointRef *ref, OTClient *currentOwner);
	// This routine creates an endpoint for you, passing back
	// the EndpointRef and the current owner.  You can then
	// call OTTransferProviderOwnership to 
	
////////////////////////////////////////////////////////////
// Initialisation and termination routines.

extern OSStatus InitProviderFactory(void);
	// Call this before calling FactoryCreateEndpoint.
	
extern void CloseProviderFactory(void);
	// Call this after you've created all the endpoints you
	// need from the factory.  Make sure you have transferred
	// the ownership of all these endpoints before calling this,
	// otherwise OT will assume that the factory still owns the
	// endpoints, and clean them up for you!
